## openturns 1.9

=== CMakeLists.txt ===
#                                               -*- cmake -*-

cmake_minimum_required (VERSION 2.8)

# By default, build in Release mode. Must appear before project() command
if (NOT DEFINED CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING "Build type")
endif ()
if (CMAKE_VERSION VERSION_GREATER 2.8)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "" Release Debug RelWithDebInfo MinSizeRel)
endif ()

project (OpenTURNS)

option (USE_BISON                    "Looks for Bison if true and then build parser"                         ON)
option (USE_FLEX                     "Looks for Flex if true and then build lexer"                           ON)
option (USE_TBB                      "Use Intel Threading Building Blocks library for multithreading"        ON)
option (USE_HMAT                     "Use HMat library"                                                      ON)
option (USE_MUPARSER                 "Use muParser libraries"                                                ON)
option (USE_LIBXML2                  "Use LibXml2 for XML support"                                           ON)
option (USE_R                        "Use R for graph output support"                                        ON)
option (USE_OPENMP                   "Use OpenMP for multithreading"                                         OFF)
option (USE_BOOST                    "Use Boost for distribution computation"                                ON)
option (USE_SPHINX                    "Use sphinx for documentation"                                          ON)
option (USE_DOXYGEN                   "Use Doxygen for API documentation"                                     ON)
option (USE_NLOPT                    "Use NLopt for additional optimization algorithms"                      ON)
option (USE_COTIRE                   "Use cotire for unity builds"                                           OFF)

option (BUILD_PYTHON                 "Build the python module for the library"                               ON)
option (BUILD_VALIDATION             "Build the validation files of the library"                             ON)
option (LINK_PYTHON_LIBRARY          "Link python modules against python library"                            ON)
option (BUILD_SHARED_LIBS            "Build shared libraries"                                                ON)

if (MSVC)
  option (BUILD_MULTIPROCESSOR       "Enable multiprocessor builds"                                          ON)
endif ()

# Defines our own module path
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)


if (USE_COTIRE)
  if (POLICY CMP0058)
    # Ninja requires custom command byproducts to be explicit
    cmake_policy (SET CMP0058 NEW)
  endif()
  set (USE_BISON OFF CACHE BOOL "" FORCE)
  set (USE_FLEX OFF CACHE BOOL "" FORCE)
  set (USE_SPHINX OFF CACHE BOOL "" FORCE)
  set (CMAKE_BUILD_WITH_INSTALL_RPATH ON)
  include (cotire)
  add_custom_target (python_unity)
endif ()

set (OPENTURNS_HOME_ENV_VAR OPENTURNS_HOME    )

if (NOT DEFINED CMAKE_INSTALL_LIBDIR)
  set (CMAKE_INSTALL_LIBDIR lib${LIB_SUFFIX})
endif ()

set (OPENTURNS_LIBRARY_PATH
      ${CMAKE_INSTALL_LIBDIR}
      CACHE PATH "The directory where the library is installed"
   )
set (OPENTURNS_INCLUDE_PATH
      include
      CACHE PATH "The directory where the header files are installed"
   )
set (OPENTURNS_CONFIG_CMAKE_PATH
      ${CMAKE_INSTALL_LIBDIR}/cmake/openturns
      CACHE PATH "The directory where the CMake files are installed"
   )
set (OPENTURNS_SYSCONFIG_PATH
      etc
      CACHE PATH "The directory where the configuration file is installed"
   )
set (OPENTURNS_DATA_PATH
      share
      CACHE PATH "The directory where the common files are installed"
   )
set (OPENTURNS_EXAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the example files are installed"
   )
set (OPENTURNS_SAMPLE_PATH
      share/openturns/examples
      CACHE PATH "The directory where the sample files are installed"
   )
set (OPENTURNS_VALIDATION_PATH
      share/openturns/validation
      CACHE PATH "The directory where validation files are installed"
   )
set (OPENTURNS_DOC_PATH
      share/openturns/doc
      CACHE PATH "The directory where the license files are installed"
   )

if (WIN32)
  set (DEFAULT_TMP TEMP)
  set (PATH_SEP "\\;")
else ()
  set(DEFAULT_TMP /tmp)
  set (PATH_SEP ":")
endif()

set (OPENTURNS_TEMPDIR
      ${DEFAULT_TMP}
      CACHE PATH "The directory for temporary files. /tmp by default."
   )
set (TEMPDIR ${OPENTURNS_TEMPDIR})

# WARNING: This is where variables without OPENTURNS_ prefix are defined !
foreach (_var INSTALL_PATH LIBRARY_PATH INCLUDE_PATH CONFIG_CMAKE_PATH SYSCONFIG_PATH DATA_PATH EXAMPLE_PATH SAMPLE_PATH VALIDATION_PATH DOC_PATH)
  file (TO_NATIVE_PATH "${OPENTURNS_${_var}}" NATIVE_OPENTURNS_${_var})
  if (NOT IS_ABSOLUTE ${NATIVE_OPENTURNS_${_var}})
    file (TO_NATIVE_PATH ${CMAKE_INSTALL_PREFIX}/${OPENTURNS_${_var}} NATIVE_OPENTURNS_${_var})
  endif ()
  string(REPLACE "\\" "\\\\" ${_var} ${NATIVE_OPENTURNS_${_var}})
endforeach (_var)

# CMake 2.x does not define MSVC when using Intel compiler on Windows, see
# http://public.kitware.com/Bug/view.php?id=14476
if (WIN32 AND CMAKE_CXX_COMPILER_ID STREQUAL "Intel")
  set(WINTEL TRUE)
endif()


if (NOT LAPACKE_FOUND)
  # workaround for cmake issue #0009976
  if (CMAKE_VERSION VERSION_LESS 2.8.4)
    enable_language (Fortran)
  endif ()
  find_package (LAPACK REQUIRED)
  if (LAPACK_FOUND)
    set (OPENTURNS_HAVE_LAPACK TRUE)
    list (APPEND OPENTURNS_LIBRARIES ${LAPACK_LIBRARIES})
  endif ()
endif ()


if (USE_BISON)
  find_package (BISON 2.4)
  if (BISON_FOUND)
    set (OPENTURNS_HAVE_BISON TRUE)
  endif ()
endif ()

if (USE_FLEX)
  find_package (FLEX)
  if (FLEX_FOUND)
    set (OPENTURNS_HAVE_FLEX TRUE)
  endif ()
endif ()

if (USE_TBB)
  find_package (TBB)
endif ()
if (TBB_FOUND)
  set (OPENTURNS_HAVE_TBB_TBB_H TRUE)
  set (OPENTURNS_HAVE_TBB TRUE)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${TBB_INCLUDE_DIRS})
  list (APPEND OPENTURNS_LIBRARIES ${TBB_LIBRARIES})
  if (MSVC OR WINTEL)
    set (OPENTURNS_TBB_NO_IMPLICIT_LINKAGE ON CACHE BOOL "Prevent implicit linkage against tbb.lib ")
  endif ()
endif ()

if (USE_MUPARSER)
  find_package (muParser 1.32)
endif ()
if (MUPARSER_FOUND)
  set (OPENTURNS_HAVE_MUPARSER TRUE)
  list (APPEND OPENTURNS_LIBRARIES ${MUPARSER_LIBRARIES})
  list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${MUPARSER_INCLUDE_DIRS})
endif ()

if (USE_HMAT)
  find_package (HMAT 1.2 NO_MODULE)
endif ()
if (HMAT_FOUND)
  set (OPENTURNS_HAVE_HMAT TRUE)
  list (APPEND OPENTURNS_LIBRARIES ${HMAT_LIBRARIES})
  list (APPEND OPENTURNS_INCLUDE_DIRS ${HMAT_INCLUDE_DIRS})
endif ()

if (USE_DOXYGEN)
  find_package (Doxygen)
endif ()

if (USE_LIBXML2)
  find_package (LibXml2)
endif ()
if (LIBXML2_FOUND)
  set (OPENTURNS_HAVE_LIBXML2 TRUE)
  list (APPEND OPENTURNS_DEFINITIONS ${LIBXML2_DEFINITIONS})
  list (APPEND OPENTURNS_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})
  list (APPEND OPENTURNS_LIBRARIES ${LIBXML2_LIBRARIES})
endif ()

if (MSVC OR WINTEL)
  set (CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES} ${CMAKE_CURRENT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
  include_directories (${PROJECT_SOURCE_DIR}/lib/include/pthread_win32 ${CMAKE_CURRENT_SOURCE_DIR}/lib/include)
endif ()
find_package (Threads)
if (Threads_FOUND)
  list (APPEND OPENTURNS_INCLUDE_DIRS ${THREADS_INCLUDE_DIRS})
  list (APPEND OPENTURNS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT})
endif ()

if (MSVC OR WINTEL)
  set (BOOST_REQUIRED_ARG REQUIRED)
  set (USE_BOOST ON CACHE INTERNAL "Force use of Boost on Windows")
endif ()
if (USE_BOOST)
  # doesn't pass all tests with boost <=1.42 (debian6)
  # but at least pass with 1.46 (ubuntu precise)
  find_package (Boost 1.46 ${BOOST_REQUIRED_ARG})
  if (Boost_FOUND)
    set (OPENTURNS_HAVE_BOOST TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${Boost_INCLUDE_DIRS})
  endif ()
endif ()

if (USE_R)
  find_package (R COMPONENTS base rot)
endif ()

if (USE_OPENMP)
  find_package (OpenMP)
  if (OPENMP_FOUND)
    set (CMAKE_CXX_FLAGS "${OpenMP_CXX_FLAGS} ${CMAKE_CXX_FLAGS}")
  endif ()
endif ()

if (USE_NLOPT)
  find_package (NLopt)
  if (NLOPT_FOUND)
    set (OPENTURNS_HAVE_NLOPT TRUE)
    list (APPEND OPENTURNS_PRIVATE_INCLUDE_DIRS ${NLOPT_INCLUDE_DIRS})
    list (APPEND OPENTURNS_LIBRARIES ${NLOPT_LIBRARIES})
  endif ()
endif ()

if (MSVC)
  if (BUILD_MULTIPROCESSOR)
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /MP")
  endif ()
  # Disable some warnings
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /wd4197 /wd4244 /wd4251 /wd4267 /wd4996")
endif ()

include (TestBigEndian)
test_big_endian (__BIG_ENDIAN__) 

try_compile(OPENTURNS_UNSIGNEDLONG_SAME_AS_UINT64
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/cmake/unsignedlong_same_as_uint64_t.cxx)

# Find system prerequisites
include (CheckIncludeFile)
check_include_file (assert.h      OPENTURNS_HAVE_ASSERT_H     )
check_include_file (dirent.h      OPENTURNS_HAVE_DIRENT_H     )
check_include_file (errno.h       OPENTURNS_HAVE_ERRNO_H      )
check_include_file (inttypes.h    OPENTURNS_HAVE_INTTYPES_H   )
check_include_file (libgen.h      OPENTURNS_HAVE_LIBGEN_H   )
check_include_file (math.h        OPENTURNS_HAVE_MATH_H       )
check_include_file (pthread.h     OPENTURNS_HAVE_PTHREAD_H    )
check_include_file (signal.h      OPENTURNS_HAVE_SIGNAL_H     )
check_include_file (stdbool.h     OPENTURNS_HAVE_STDBOOL_H    )
check_include_file (stdint.h      OPENTURNS_HAVE_STDINT_H     )
check_include_file (stdlib.h      OPENTURNS_HAVE_STDLIB_H     )
check_include_file (string.h      OPENTURNS_HAVE_STRING_H     )
check_include_file (strings.h     OPENTURNS_HAVE_STRINGS_H    )
check_include_file (sys/stat.h    OPENTURNS_HAVE_SYS_STAT_H   )
check_include_file (sys/time.h    OPENTURNS_HAVE_SYS_TIME_H   )
check_include_file (sys/types.h   OPENTURNS_HAVE_SYS_TYPES_H  )
check_include_file (sys/un.h      OPENTURNS_HAVE_SYS_UN_H     )
check_include_file (unistd.h      OPENTURNS_HAVE_UNISTD_H     )

# Some useful macros to ease CMakeLists.txt file writing
set (SOURCEFILES "" CACHE INTERNAL "List of source files to compile")
macro (ot_add_source_file FILENAME)
  set (sf ${SOURCEFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME})
  set (SOURCEFILES ${sf} CACHE INTERNAL "List of source files to compile")
endmacro (ot_add_source_file)

set (BUILT_SOURCEFILES "" CACHE INTERNAL "List of source files to compile")
macro (ot_add_built_source_file FILENAME)
  set (sf ${BUILT_SOURCEFILES} ${FILENAME})
  set (BUILT_SOURCEFILES ${sf} CACHE INTERNAL "List of built source files to compile")
endmacro (ot_add_built_source_file)

set (HEADERFILES "" CACHE INTERNAL "List of header files to install")
macro (ot_install_header_file FILENAME)
  set (hf ${HEADERFILES} ${CMAKE_CURRENT_SOURCE_DIR}/openturns/${FILENAME})
  set (HEADERFILES ${hf} CACHE INTERNAL "List of header files to install")
endmacro (ot_install_header_file)

set (SWIGFILES "" CACHE INTERNAL "List of SWIG files to install")
macro (ot_install_swig_file FILENAME)
  set (hf ${SWIGFILES} ${CMAKE_CURRENT_SOURCE_DIR}/${FILENAME})
  set (SWIGFILES ${hf} CACHE INTERNAL "List of SWIG files to install")
endmacro (ot_install_swig_file)

set (INTERNAL_INCLUDE_DIRS "" CACHE INTERNAL "List of directories with header files needed for build")
macro (ot_add_current_dir_to_include_dirs)
  set (inc_dirs ${INTERNAL_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR})
  set (INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build")
endmacro (ot_add_current_dir_to_include_dirs)
macro (ot_add_build_dir_to_include_dirs DIR)
  set (inc_dirs ${INTERNAL_INCLUDE_DIRS} ${DIR})
  set (INTERNAL_INCLUDE_DIRS ${inc_dirs} CACHE INTERNAL "List of directories with header files needed for build")
endmacro (ot_add_build_dir_to_include_dirs)

# Add definitions according to the prerequisites found
add_definitions(-DHAVE_CONFIG_H)

=== lib/CMakeLists.txt ===
#                                               -*- cmake -*-

# Recurse in subdirectories
add_subdirectory (include)
add_subdirectory (src)
add_subdirectory (etc)

# Build the OpenTURNSConfig.cmake file
set (OPENTURNS_LIBRARY_DIRS            ${LIBRARY_PATH})
set (OPENTURNS_LIBRARY                 OT)
list (APPEND OPENTURNS_LIBRARIES       ${OPENTURNS_LIBRARY})
set (OPENTURNS_INCLUDE_DIR             ${INCLUDE_PATH})
list (INSERT OPENTURNS_INCLUDE_DIRS 0  ${OPENTURNS_INCLUDE_DIR})

set (OPENTURNS_ROOT_DIR       ${INSTALL_PATH})
set (OPENTURNS_VERSION_STRING ${PACKAGE_VERSION})
set (OPENTURNS_VERSION_MAJOR  ${CPACK_PACKAGE_VERSION_MAJOR})
set (OPENTURNS_VERSION_MINOR  ${CPACK_PACKAGE_VERSION_MINOR})
set (OPENTURNS_VERSION_PATCH  ${CPACK_PACKAGE_VERSION_PATCH})
set (OPENTURNS_USE_FILE       ${CONFIG_CMAKE_PATH}/UseOpenTURNS.cmake)

if(CMAKE_VERSION VERSION_LESS 2.8.8)
  # CMakePackageConfigHelpers is not available
  set (PACKAGE_INIT "
# Generated by a CMake version without CMakePackageConfigHelpers.
macro(set_and_check _var _value)
  set(\${_var} \"\${_value}\")
endmacro(set_and_check _var _value)
"    )
  foreach (_var
      OPENTURNS_USE_FILE
      OPENTURNS_ROOT_DIR
      OPENTURNS_INCLUDE_DIR
      OPENTURNS_INCLUDE_DIRS
      OPENTURNS_LIBRARY_DIRS
      OPENTURNS_SWIG_INCLUDE_DIRS)
    set(PACKAGE_${_var} ${${_var}})
  endforeach ()


  configure_file (OpenTURNSConfig.cmake.in
                   ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
                   @ONLY
                )
                 
  install (FILES UseOpenTURNS.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
            DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
     )

else (CMAKE_VERSION VERSION_LESS 2.8.8)
  include(CMakePackageConfigHelpers)
  configure_package_config_file (
    OpenTURNSConfig.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
    INSTALL_DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
    PATH_VARS
      OPENTURNS_USE_FILE
      OPENTURNS_ROOT_DIR
      OPENTURNS_INCLUDE_DIR
      OPENTURNS_INCLUDE_DIRS
      OPENTURNS_LIBRARY_DIRS
      OPENTURNS_SWIG_INCLUDE_DIRS
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
                               )                   
  write_basic_package_version_file(OpenTURNSConfigVersion.cmake VERSION ${OPENTURNS_VERSION_STRING} COMPATIBILITY AnyNewerVersion)               

  install (FILES UseOpenTURNS.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfig.cmake
                  ${CMAKE_CURRENT_BINARY_DIR}/OpenTURNSConfigVersion.cmake
            DESTINATION ${OPENTURNS_CONFIG_CMAKE_PATH}
         )
endif (CMAKE_VERSION VERSION_LESS 2.8.8)

# Recurse in subdirectories : test should be run after src (for target OT to be built)
add_subdirectory (test)

if (DOXYGEN_FOUND)

  # generate Doxyfile
  set (VERSION ${PACKAGE_VERSION})
  set (builddir ${CMAKE_CURRENT_BINARY_DIR})
  set ( top_srcdir ${CMAKE_CURRENT_SOURCE_DIR})
  configure_file (${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in
                   ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
                    @ONLY)
                    
  # generate html doc and compress it
  add_custom_target (html 
                      COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/doc
                      COMMAND ${DOXYGEN_EXECUTABLE} Doxyfile
                      COMMAND tar czf doc-api-${PACKAGE_VERSION}.tar.gz doc
                      COMMAND tar cjf doc-api-${PACKAGE_VERSION}.tar.bz2 doc
                     )                   
                      
endif (DOXYGEN_FOUND)

install (FILES ${HEADERFILES}
          DESTINATION ${INCLUDE_PATH}/openturns
       )

=== python/CMakeLists.txt ===
#                                               -*- cmake -*-

include_directories (${PYTHON_INCLUDE_DIRS})

# Recurse in subdirectories
add_subdirectory (src)
add_subdirectory (test)

=== distro/windows/Makefile ===
#
# Compile and create OpenTURNS installer for windows
#
# Rules dependencies make things done in the right order, however it does not
# detect if OpenTURNS sources has changed. This has to be specified manually:
# - to recompute a rules, remove the corresponding file
#   i.e. some OpenTURNS .cxx have changed:
#     rm ot-compile; make
# - to recompute every rules: make clean; make
#

###############################################################################
# adapt these following lines to your configuration :

# compiler prefix
ARCH=i686
TARGET = $(ARCH)-w64-mingw32

# OpenTurns paths
OT_SRC    ?= $(PWD)/../..
OT_BUILD  ?= $(OT_SRC)/build-$(TARGET)
OT_PREFIX ?= $(OT_BUILD)/install

OT_VERSION ?= $(shell cat ../../VERSION)

WINDEPS = $(PWD)/openturns-developers-windeps

# Wine
WINE=/usr/bin/wine
WINE_PREFIX = $(WINDEPS)/wine-$(ARCH)
export WINEPREFIX = $(WINE_PREFIX)
ifeq ($(ARCH), i686)
export WINEARCH = win32
else
export WINEARCH = win64
endif

MINGW_PREFIX = $(WINDEPS)/mingw-w64-x86_64/usr

# Python
PYBASEVER = 2.7
PYBASEVER_NODOT = $(shell echo $(PYBASEVER) | sed "s|\.||g")
PYBASEVER_MAJOR = $(shell echo $(PYBASEVER) | head -c 1)
PYTHON_EXECUTABLE=$(MINGW_PREFIX)/$(TARGET)/bin/python$(PYBASEVER_NODOT).exe
export PYTHONHOME := $(MINGW_PREFIX)/$(TARGET)
export PYTHONPATH := $(MINGW_PREFIX)/$(TARGET)/lib/python$(PYBASEVER_NODOT)


R_PATH = $(WINDEPS)/opt/R-2.12.0
PATH := $(R_PATH)/bin:$(PATH)
CMAKE=cmake


# launch OpenTURNS checktests before creating the installer (y,n)
CHECK_OT=y

JOBS=$(shell getconf _NPROCESSORS_ONLN)
JOBS_PYTHON=$(JOBS)
JOBS_TEST=$(JOBS)
export PATH := $(MINGW_PREFIX)/bin:$(PATH)

DEBUG_OT=n


###############################################################################
# rules:

.PHONY: all clean-python clean mrproper


all: ot-installer


ot-check-compiler:
	@echo -n "Check OpenTURNS dependencies: " 
	@ls $(OT_SRC) $(PYTHON_EXECUTABLE) > /dev/null
	@echo "ok"
	touch ot-check-compiler
ifeq ($(PYBASEVER_MAJOR),3)
	wine wineboot
	xvfb-run winetricks -q vcrun2015
endif

ot-config: ot-check-compiler
	-mkdir -p $(OT_BUILD)
	cp $(MINGW_PREFIX)/share/mingw/toolchain-$(TARGET).cmake $(OT_BUILD)
	echo "set(CMAKE_FIND_ROOT_PATH $(MINGW_PREFIX)/$(TARGET))" >> $(OT_BUILD)/toolchain-$(TARGET).cmake
	cp $(MINGW_PREFIX)/$(TARGET)/bin/python$(PYBASEVER_NODOT).dll $(OT_BUILD)
	cd $(OT_BUILD) && rm -f CMakeCache.txt && $(CMAKE) \
	  -DCMAKE_TOOLCHAIN_FILE=toolchain-$(TARGET).cmake \
	  -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	  -DCMAKE_C_FLAGS_RELWITHDEBINFO="-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions --param=ssp-buffer-size=4" \
	  -DCMAKE_CXX_FLAGS_RELWITHDEBINFO="-O2 -g -pipe -Wall -Wp,-D_FORTIFY_SOURCE=2 -fexceptions --param=ssp-buffer-size=4 -D_hypot=hypot" \
	  -DPYTHON_INCLUDE_DIR=$(MINGW_PREFIX)/$(TARGET)/include/python$(PYBASEVER_NODOT) \
	  -DPYTHON_INCLUDE_DIR2=$(MINGW_PREFIX)/$(TARGET)/include/python$(PYBASEVER_NODOT) \
	  -DPYTHON_LIBRARY=$(MINGW_PREFIX)/$(TARGET)/lib/libpython$(PYBASEVER_NODOT).dll.a \
	  -DPYTHON_EXECUTABLE=$(PYTHON_EXECUTABLE) \
	  -DR_EXECUTABLE=$(R_PATH)/bin/R.exe \
	  -DCMAKE_INSTALL_PREFIX=$(OT_PREFIX) \
	  -DUSE_TBB=OFF \
	  -DUSE_SPHINX=OFF \
	  -DCMAKE_CROSSCOMPILING_EMULATOR=$(WINE) \
	  -DUSE_COTIRE=ON -DCOTIRE_MAXIMUM_NUMBER_OF_UNITY_INCLUDES="-j$(JOBS)" \
	  $(OT_SRC)
	touch ot-config

ot-compile: ot-config
	cd $(OT_BUILD) && make OT_unity -j$(JOBS)
	cd $(OT_BUILD) && make python_unity -j$(JOBS_PYTHON)
	touch ot-compile

ot-install: ot-compile
	cd $(OT_BUILD) && make install/fast -j$(JOBS)
ifeq ($(DEBUG_OT),n)
	$(TARGET)-strip --strip-unneeded $(OT_PREFIX)/bin/*.dll
	$(TARGET)-strip -g $(OT_PREFIX)/lib/*.a
	$(TARGET)-strip --strip-unneeded $(OT_PREFIX)/Lib/site-packages/*/*.pyd
endif
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libgcc_s_*-1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libquadmath-0.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libgfortran-3.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libstdc++-6.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libwinpthread-1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libblas.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/liblapack.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libiconv-2.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/liblzma-5.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libxml2-2.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/muparser.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/zlib1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libnlopt-0.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libgomp-1.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libcblas.dll $(OT_PREFIX)/bin
	cp $(MINGW_PREFIX)/$(TARGET)/bin/libhmat-oss.dll $(OT_PREFIX)/bin
	tar cjf openturns-mingw-$(OT_VERSION)-py$(PYBASEVER)-$(ARCH).tar.bz2 --directory $(OT_PREFIX)/.. `basename $(OT_PREFIX)`
	touch ot-install

ot-test: ot-install
	cd $(OT_BUILD) && make all_unity -j$(JOBS)
ifeq ($(CHECK_OT),y)
	cp $(OT_PREFIX)/bin/*.dll $(OT_BUILD)/lib/test
	cp $(OT_PREFIX)/bin/*.dll $(OT_BUILD)/python/test
	cp $(MINGW_PREFIX)/$(TARGET)/bin/python$(PYBASEVER_NODOT).dll $(OT_BUILD)/python/test
	cd $(OT_BUILD) && ctest -j$(JOBS_TEST) --output-on-failure --timeout 1500
endif
	touch ot-test

ot-install-test: ot-test
	cp $(OT_SRC)/lib/test/*.expout $(OT_PREFIX)/share/openturns/examples
	for exp_file in `find $(OT_SRC)/python/test -name "t_*.expout"`; do \
	  base_file=`basename $${exp_file} .expout`; \
	  cp $${exp_file} $(OT_PREFIX)/share/openturns/examples/$${base_file}.py.expout; done
	cp $(OT_BUILD)/lib/test/*.exe $(OT_PREFIX)/share/openturns/examples
ifeq ($(DEBUG_OT),n)
	$(TARGET)-strip --strip-all $(OT_PREFIX)/share/openturns/examples/*.exe
endif
	touch ot-install-test

ot-check-installer: ot-install
	@echo -n "Check OpenTURNS prefix: "
	@ls $(OT_PREFIX) > /dev/null
	@echo "ok"
	@echo -n "Check nsis compiler: "
	@makensis -VERSION > /dev/null 2>&1
	@echo "ok"
	@echo "OpenTURNS installer dependencies seems all right."
	touch ot-check-installer

ot-module-installer: ot-check-installer
	sed "s|@version@|$(OT_VERSION)|g" OpenTURNSDoc.url.in > OpenTURNSDoc.url
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYBASEVER=$(PYBASEVER) -DPYBASEVER_NODOT=$(PYBASEVER_NODOT) -DARCH=$(ARCH) openturns.nsi
	touch ot-module-installer

ot-dev-installer: ot-install-test ot-check-installer
	makensis -DOPENTURNS_PREFIX=$(OT_PREFIX) -DPRODUCT_VERSION=$(OT_VERSION) -DPYBASEVER=$(PYBASEVER) -DPYBASEVER_NODOT=$(PYBASEVER_NODOT) -DARCH=$(ARCH) openturns_developer.nsi
	touch ot-dev-installer


ot-installer: ot-module-installer ot-dev-installer
	@echo "ok"	


clean:
	-rm -f ot-*
	-cd $(OT_BUILD) && make clean


mrproper:
	-rm -f ot-*
	-rm -rf $(OT_PREFIX) $(OT_BUILD)
	-rm -f *.exe

=== lib/include/CMakeLists.txt ===
#                                               -*- cmake -*-

if (CMAKE_Fortran_COMPILER_WORKS)
  # workaround for bug #0014358
  if (CMAKE_VERSION VERSION_LESS 2.8.13 AND NOT DEFINED FortranCInterface_EXE)
    set (FortranCInterface_EXE ${CMAKE_BINARY_DIR}/CMakeFiles/FortranCInterface/FortranCInterface${CMAKE_EXECUTABLE_SUFFIX})
  endif ()

  include (FortranCInterface)
  FortranCInterface_HEADER (FortranCInterface.h)
endif ()

ot_add_current_dir_to_include_dirs ()
ot_add_build_dir_to_include_dirs (${CMAKE_CURRENT_BINARY_DIR})

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/OTconfig.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns/OTconfig.h
                @ONLY
              )

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/installed-OTconfig.h.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns/installed-OTconfig.h
                @ONLY
              )

set (ot_configure_args)
if (NOT ot_configure_date)
  if (UNIX)
    execute_process (COMMAND date "+%a, %d %b %Y %H:%M:%S %z"
                      OUTPUT_VARIABLE ot_configure_date
                      OUTPUT_STRIP_TRAILING_WHITESPACE
                   )
  elseif(MSVC OR WINTEL)
    execute_process (COMMAND cmd " /C date /T"
                      OUTPUT_VARIABLE ot_configure_date
                      OUTPUT_STRIP_TRAILING_WHITESPACE)
  endif()
  set (ot_configure_date "${ot_configure_date}" CACHE STRING "First configure date.")
endif ()
if (NOT ot_revision)
  execute_process (COMMAND git rev-parse --short HEAD
                    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
                    OUTPUT_VARIABLE ot_revision
                    OUTPUT_STRIP_TRAILING_WHITESPACE
                 )
  set (ot_revision "${ot_revision}" CACHE STRING "Revision number.")
endif ()
mark_as_advanced(ot_configure_date ot_revision)
set (prefix ${CMAKE_INSTALL_PREFIX})
set (PACKAGE openturns)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/OTconfigure_args.hxx.in
                ${CMAKE_CURRENT_BINARY_DIR}/openturns/OTconfigureArgs.hxx
                @ONLY
             )

install (DIRECTORY openturns DESTINATION ${OPENTURNS_INCLUDE_PATH})
install (FILES ${CMAKE_CURRENT_BINARY_DIR}/openturns/installed-OTconfig.h
          DESTINATION ${OPENTURNS_INCLUDE_PATH}/openturns
          RENAME OTconfig.h
       )

if (MSVC OR WINTEL)
    install (FILES pthread_win32/pthread.h
                    pthread_win32/semaphore.h
                    pthread_win32/unistd.h
              DESTINATION ${OPENTURNS_INCLUDE_PATH}
           )
endif ()

=== lib/src/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()
ot_install_header_file (OT.hxx)
ot_add_source_file (openturns_library_ok.c)

foreach (include_dir ${OPENTURNS_INCLUDE_DIRS})
  set (EXTRA_CPPFLAGS "${EXTRA_CPPFLAGS} -I${include_dir}")
endforeach ()
configure_file (${CMAKE_CURRENT_SOURCE_DIR}/openturns-config-build.in
                 ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
                 @ONLY
              )
set (prefix "${CMAKE_INSTALL_PREFIX}")
set (exec_prefix "${CMAKE_INSTALL_PREFIX}")
set (libdir "${INSTALL_PATH}/lib${LIB_SUFFIX}")
set (PACKAGE "${CPACK_PACKAGE_NAME}")
install (PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/openturns-config-build
          DESTINATION ${INSTALL_PATH}/bin
          RENAME openturns-config
       )

# Recurse in subdirectories
add_subdirectory (Base)
add_subdirectory (Uncertainty)

# Build main library
foreach (built_source ${BUILT_SOURCEFILES})
  set_source_files_properties (${built_source} PROPERTIES GENERATED TRUE)
endforeach (built_source)
include_directories (${INTERNAL_INCLUDE_DIRS})
link_directories (${CMAKE_Fortran_IMPLICIT_LINK_DIRECTORIES})
add_library (OT ${SOURCEFILES} ${BUILT_SOURCEFILES})
set_target_properties (OT PROPERTIES POSITION_INDEPENDENT_CODE ON)

if (BUILD_SHARED_LIBS)
  set_target_properties(OT PROPERTIES COMPILE_DEFINITIONS "OT_DLL_EXPORTS")
endif ()

# soversion
if (NOT DEFINED LIB_VERSION) 
  set (LIB_VERSION 0.0.0)
endif ()
if (NOT DEFINED LIB_SOVERSION) 
  set (LIB_SOVERSION 0)
endif ()
set_target_properties (OT PROPERTIES SOVERSION ${LIB_SOVERSION})
set_target_properties (OT PROPERTIES VERSION ${LIB_VERSION})

if (BISON_FOUND AND FLEX_FOUND)
  add_dependencies (OT generate_csv_lexer)
  add_dependencies (OT generate_csv_parser)
endif ()

target_link_libraries (OT ${OPENTURNS_LIBRARIES})
target_link_libraries (OT ${OPENTURNS_PRIVATE_LIBRARIES})

# Build an empty executable to check link dependencies and completeness
add_executable (linktest main.cxx)
target_link_libraries (linktest OT)
set_target_properties (linktest PROPERTIES
                                 INSTALL_RPATH "${CMAKE_INSTALL_RPATH};${CMAKE_BINARY_DIR}/lib/src")

# Add targets to the build-tree export set
export(TARGETS OT FILE "${PROJECT_BINARY_DIR}/OpenTURNS-Targets.cmake")

# Install the export set for use with the install-tree
install(EXPORT OpenTURNS-Targets DESTINATION
  "${OPENTURNS_CONFIG_CMAKE_PATH}"
    COMPONENT    Development)

# Install rules for library and executable
install (TARGETS OT
          EXPORT  OpenTURNS-Targets
          RUNTIME DESTINATION bin
          LIBRARY DESTINATION ${LIBRARY_PATH}
          ARCHIVE DESTINATION ${LIBRARY_PATH}
       )

if (UNIX AND BUILD_SHARED_LIBS)
  set (OT_GDB_PY ${CMAKE_SHARED_LIBRARY_PREFIX}OT${CMAKE_SHARED_LIBRARY_SUFFIX}.${LIB_VERSION}-gdb.py)
  execute_process (COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/libOT-gdb.py ${CMAKE_CURRENT_BINARY_DIR}/${OT_GDB_PY})
  install (FILES libOT-gdb.py DESTINATION ${OPENTURNS_DATA_PATH}/gdb/auto-load/${LIBRARY_PATH} RENAME ${OT_GDB_PY})
endif ()


if (USE_COTIRE)
  set (COTIRE_UNITY_SOURCE_EXCLUDE_EXTENSIONS "c;cc")
  cotire (OT)
endif ()

=== lib/test/CMakeLists.txt ===
#                                               -*- cmake -*-
#
#  CMakeLists.txt
#
#  Copyright 2005-2017 Airbus-EDF-IMACS-Phimeca
#
#  This library is free software: you can redistribute it and/or modify
#  it under the terms of the GNU Lesser General Public License as published by
#  the Free Software Foundation, either version 3 of the License, or
#  (at your option) any later version.
#
#  This library is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  along with this library.  If not, see <http://www.gnu.org/licenses/>.
#
#

set (NEW_PATH "${INSTALL_DESTDIR}${EXAMPLE_PATH}${PATH_SEP}$ENV{PATH}")

set (ADAPT_CHECK_TESTS_EXPONENT)
set (REPLACE_EOL " | cat ")
if (MINGW)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set (ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2")

  if (CMAKE_SIZEOF_VOID_P EQUAL 4)
    add_library (CRT_fp8 STATIC CRT_fp8.c)
  endif ()
endif ()

set (CHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${CMAKE_BINARY_DIR}/lib/etc"
                        ${ADAPT_CHECK_TESTS_EXPONENT} 
   )

# This macro compiles on the fly and run the corresponding pre-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
set (CHECK_TO_BE_RUN)
macro (ot_check_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.cxx)
  set (TESTNAME_SRCS ${TESTNAME_SRC})
  add_executable (${TESTNAME_TGT} EXCLUDE_FROM_ALL ${TESTNAME_SRCS})
  add_dependencies(tests ${TESTNAME_TGT}) 
  target_link_libraries (${TESTNAME_TGT} OT)
  if (MINGW AND CMAKE_SIZEOF_VOID_P EQUAL 4)
    target_link_libraries (${TESTNAME_TGT} CRT_fp8)
  endif ()
  set_target_properties (${TESTNAME_TGT} PROPERTIES
                                          INSTALL_RPATH "${CMAKE_BINARY_DIR}/lib/src;${CMAKE_INSTALL_RPATH}")
  set (TESTNAME_LOC ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}${CMAKE_EXECUTABLE_SUFFIX})

  set (_CMD)
  set (_PRE)
  set (_POST)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PRE)
      set (_CMD PRE)
    elseif (${ARG} MATCHES POST)
      set (_CMD POST)
    elseif (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else (${ARG} MATCHES PRE)
      if (${_CMD} MATCHES PRE)
        set (_PRE "${_PRE} ${_ARG} && ")
      elseif (${_CMD} MATCHES POST)
        set (_POST "${_POST} && ${_ARG}")
      elseif (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif  (${_CMD} MATCHES PRE)
      set (_CMD)
    endif (${ARG} MATCHES PRE)
  endforeach (_ARG)

  if (_IGNOREOUT)
    set (COMMAND "(${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set (COMMAND "${_PRE}${COMMAND}${_POST}")
  endif (_PRE OR _POST)

  add_test (cppcheck_${TESTNAME} "sh" "-c" "${COMMAND}")
  set_tests_properties (cppcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${CHECK_ENVIRONMENT}")
  list (APPEND CHECK_TO_BE_RUN ${TESTNAME_TGT})
  install (FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH}
         )

  if (USE_COTIRE)
    option (COTIRE_TESTS "cotire tests" ON)
    if (COTIRE_TESTS)
      set_target_properties (${TESTNAME_TGT} PROPERTIES COTIRE_ENABLE_PRECOMPILED_HEADER FALSE)
      cotire (${TESTNAME_TGT})
    endif ()
  endif ()

endmacro (ot_check_test)


include_directories (${INTERNAL_INCLUDE_DIRS})

## Pre-installation tests

# Common
ot_check_test (Object_std)
ot_check_test (OStream_std)
ot_check_test (PersistentObject_std)
ot_check_test (Pointer_std)
ot_check_test (Pointer_cast)
ot_check_test (Exception_std)
ot_check_test (Log_std)
ot_check_test (IdFactory_std IGNOREOUT)
ot_check_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
ot_check_test (Study_saveload )
endif ()
ot_check_test (ResourceMap_std IGNOREOUT)
ot_check_test (Catalog_std IGNOREOUT)
ot_check_test (AtomicFunctions_std IGNOREOUT)

# Type
ot_check_test (Collection_std)
ot_check_test (Indices_std)
ot_check_test (Description_std)
ot_check_test (Point_std)
ot_check_test (Point_description)
ot_check_test (Matrix_std)
ot_check_test (IdentityMatrix_std)
ot_check_test (Tensor_std)
ot_check_test (ComplexTensor_std)
ot_check_test (SymmetricTensor_std)
ot_check_test (SquareMatrix_std)
ot_check_test (TriangularMatrix_std)
ot_check_test (SymmetricMatrix_std)
ot_check_test (Matrix_solve)
ot_check_test (Matrix_decomposition)
ot_check_test (SquareMatrix_lapack)
ot_check_test (SymmetricMatrix_lapack)
ot_check_test (Cache_std)
ot_check_test (ComplexMatrix_std)
ot_check_test (SquareComplexMatrix_std)
ot_check_test (HermitianMatrix_std)
ot_check_test (TriangularComplexMatrix_std)

# Func
ot_check_test (LinearEvaluation_std)
ot_check_test (ConstantGradient_std)
ot_check_test (AggregatedEvaluation_std)
ot_check_test (PiecewiseLinearEvaluation_std)
ot_check_test (PiecewiseHermiteEvaluation_std)
ot_check_test (P1LagrangeEvaluation_std)
if (OPENTURNS_HAVE_MUPARSER)
ot_check_test (SymbolicEvaluation_std)
ot_check_test (SymbolicGradient_std)
ot_check_test (SymbolicHessian_std)
endif ()
ot_check_test (LinearFunction_std)
ot_check_test (LinearCombinationEvaluation_std)
ot_check_test (LinearCombinationGradient_std)
ot_check_test (LinearCombinationHessian_std)
ot_check_test (QuadraticEvaluation_std)
ot_check_test (LinearGradient_std)
ot_check_test (ConstantHessian_std)
ot_check_test (MethodBoundEvaluation_std)
ot_check_test (SymbolicFunction_std)
ot_check_test (IndicatorFunction_std)
ot_check_test (AggregatedFunction_std)
ot_check_test (DualLinearCombinationFunction_std)
ot_check_test (LinearCombinationFunction_std)
ot_check_test (Function_operations)
ot_check_test (ParametricFunction_std)
ot_check_test (DatabaseFunction_std)
ot_check_test (Function_history)

if (R_base_FOUND)
ot_check_test (Function_draw)
endif ()
ot_check_test (MonomialFunction_std)
ot_check_test (MonomialFunctionFactory_std)
ot_check_test (TensorizedUniVariateFunctionFactory_std)

ot_check_test (UniVariatePolynomial_std)
ot_check_test (Basis_std)
ot_check_test (BasisSequence_std)
ot_check_test (LARS_std)
ot_check_test (FieldFunction_std)
ot_check_test (ValueFunction_std)
ot_check_test (VertexValueFunction_std)
ot_check_test (BoxCoxEvaluation_std)
ot_check_test (BoxCoxTransform_std)
ot_check_test (InverseBoxCoxEvaluation_std)
ot_check_test (InverseBoxCoxTransform_std)
ot_check_test (TrendEvaluation_std)
ot_check_test (TrendTransform_std)
ot_check_test (InverseTrendEvaluation_std)
ot_check_test (InverseTrendTransform_std)
ot_check_test (ExpertMixture_std)
ot_check_test (BasisFactory_std)

# Optim
ot_check_test (AbdoRackwitz_std)
ot_check_test (Cobyla_std)
ot_check_test (SQP_std)
ot_check_test (TNC_std)
ot_check_test (NearestPointChecker_std)
if (NLOPT_FOUND)
ot_check_test (NLopt_std)
endif ()
ot_check_test (MultiStart_std)

# Solver
ot_check_test (Bisection_std)
ot_check_test (Brent_std)
ot_check_test (Secant_std)
ot_check_test (RungeKutta_std)

# Stat
ot_check_test (Sample_std)
ot_check_test (Sample_split)
ot_check_test (Sample_large)
ot_check_test (Sample_computation)
ot_check_test (Sample_operators)
ot_check_test (HistoryStrategy_std)
ot_check_test (CovarianceMatrixLapack_std)
ot_check_test (CorrelationMatrix_std)
ot_check_test (TestResult_std)
if (R_rot_FOUND)
ot_check_test (LinearModelFactory_std)
ot_check_test (LinearModel_std)
endif ()
ot_check_test (Field_draw)
ot_check_test (ProcessSample_std)
ot_check_test (RandomGenerator_std)
ot_check_test (SobolSequence_std)
ot_check_test (FaureSequence_std)
ot_check_test (HaltonSequence_std)
ot_check_test (HaselgroveSequence_std)
ot_check_test (ReverseHaltonSequence_std)
ot_check_test (CorrelationAnalysis_std)
ot_check_test (TimeSeries_std)
ot_check_test (ExponentialCauchy_std)
ot_check_test (FilteringWindows_std)
ot_check_test (WelchFactory_std)
ot_check_test (ExponentialModel_std)
ot_check_test (CovarianceModel_std)
ot_check_test (DiracCovarianceModel_std)
ot_check_test (ExponentiallyDampedCosineModel_std)
ot_check_test (CauchyModel_std)
ot_check_test (SecondOrderModel_std)
ot_check_test (UserDefinedSpectralModel_std)
ot_check_test (UserDefinedCovarianceModel_std)
ot_check_test (UserDefinedStationaryCovarianceModel_std)
ot_check_test (StationaryCovarianceModelFactory_std)
ot_check_test (NonStationaryCovarianceModelFactory_std)
if (HMAT_FOUND)
ot_check_test (HMatrix_LDLt)
ot_check_test (HMatrix_LLt)
ot_check_test (HMatrix_LU)
ot_check_test (HMatrix_block_LLt)
ot_check_test (HMatrix_block_LU)
ot_check_test (DiracCovarianceModel_hmat)
endif ()

# Diff
ot_check_test (FiniteDifferenceStep_std)

# Geom
ot_check_test (Domain_std)
ot_check_test (Interval_std)
ot_check_test (IntervalMesher_std)
ot_check_test (LevelSet_std)
ot_check_test (LevelSetMesher_std)
ot_check_test (Mesh_std)
if (R_base_FOUND)
ot_check_test (Mesh_draw)
endif ()
ot_check_test (RegularGrid_std)

# Graph
if (R_base_FOUND)
ot_check_test (BarPlot_std)
ot_check_test (Cloud_std)
ot_check_test (Contour_std)
ot_check_test (Curve_std)
ot_check_test (Drawable_std)
ot_check_test (Graph_mix)
ot_check_test (Graph_export)
ot_check_test (Pairs_std)
ot_check_test (Pie_std)
ot_check_test (Polygon_std)
ot_check_test (PolygonArray_std)
ot_check_test (Staircase_std)
ot_check_test (Text_std)
endif ()

# Algo
ot_check_test (PenalizedLeastSquaresAlgorithm_std)
ot_check_test (CorrectedLeaveOneOut_std)
ot_check_test (KDTree_std)
ot_check_test (KFold_std)
ot_check_test (LeastSquaresMetaModelSelectionFactory_std)
ot_check_test (KissFFT_std)
ot_check_test (GaussKronrod_std)
ot_check_test (GaussLegendre_std)
ot_check_test (IteratedQuadrature_std)
ot_check_test (KarhunenLoeveP1Factory_std)
ot_check_test (KarhunenLoeveP1Algorithm_std)
ot_check_test (LeastSquaresMethod_std)
ot_check_test (LeastSquaresMethod_weighted)
ot_check_test (KarhunenLoeveSVDAlgorithm_std)

# Analytical
ot_check_test (Analytical_std)
ot_check_test (AnalyticalResult_std)
ot_check_test (FORM_std)
ot_check_test (FORM_AbdoRackwitz)
ot_check_test (FORM_SQP)
ot_check_test (FORM_sensitivity)
if (R_base_FOUND)
ot_check_test (FORM_draw)
endif ()
ot_check_test (SORM_std)
ot_check_test (StrongMaximumTest_std)
ot_check_test (StrongMaximumTest_tabulatedValues)
ot_check_test (StrongMaximumTest_other)

# Distribution
ot_check_test (Arcsine_std)
ot_check_test (ArcsineFactory_std)
ot_check_test (Bernoulli_std)
ot_check_test (BernoulliFactory_std)
ot_check_test (BernsteinCopulaFactory_std)
ot_check_test (Beta_std)
ot_check_test (BetaFactory_std)
ot_check_test (Binomial_std)
ot_check_test (BinomialFactory_std)
ot_check_test (Burr_std)
ot_check_test (BurrFactory_std)
ot_check_test (Chi_std)
ot_check_test (ChiFactory_std)
ot_check_test (ChiSquare_std)
ot_check_test (ChiSquareFactory_std)
ot_check_test (ComposedCopula_std)
ot_check_test (ComposedDistribution_std)
ot_check_test (ComposedDistribution_large)
ot_check_test (CompositeDistribution_std)
ot_check_test (ConditionalDistribution_std)
ot_check_test (CumulativeDistributionNetwork_std)
ot_check_test (Dirac_std)
ot_check_test (DiracFactory_std)
ot_check_test (Dirichlet_std)
ot_check_test (DirichletFactory_std)
ot_check_test (Epanechnikov_std)
ot_check_test (Exponential_std)

=== python/src/CMakeLists.txt ===
#                                               -*- cmake -*-

add_definitions (${OPENTURNS_SWIG_DEFINITIONS})

# generate SWIG runtime header
set (SWIG_PYTHON_OPTIONS "-python")
execute_process (COMMAND ${CMAKE_COMMAND} -E make_directory ${CMAKE_CURRENT_BINARY_DIR}/openturns)
add_custom_command (OUTPUT  ${CMAKE_CURRENT_BINARY_DIR}/openturns/swig_runtime.hxx
                     COMMAND ${SWIG_EXECUTABLE}
                     ARGS ${SWIG_PYTHON_OPTIONS} ${CMAKE_SWIG_FLAGS} ${OPENTURNS_SWIG_DEFINITIONS} -external-runtime ${CMAKE_CURRENT_BINARY_DIR}/openturns/swig_runtime.hxx
                     COMMENT "Swig header")
add_custom_target (generate_swig_runtime DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/openturns/swig_runtime.hxx)
add_custom_target (generate_docstrings)

include_directories (${CMAKE_CURRENT_BINARY_DIR})

include_directories (BEFORE ${INTERNAL_INCLUDE_DIRS})
include_directories (${CMAKE_CURRENT_SOURCE_DIR})

set (OPENTURNS_PYTHON_MODULES)
macro (ot_add_python_module MODULENAME SOURCEFILE)
  set_source_files_properties (${SOURCEFILE} PROPERTIES CPLUSPLUS ON)
  set_source_files_properties (${SOURCEFILE} PROPERTIES SWIG_MODULE_NAME ${MODULENAME})
  ot_install_swig_file (${SOURCEFILE})
  if (${ARGC} GREATER 2)
    set (SWIG_MODULE_${MODULENAME}_EXTRA_DEPS ${ARGN})
    list (APPEND SWIG_MODULE_${MODULENAME}_EXTRA_DEPS openturns/PythonWrappingFunctions.hxx)
  endif ()

  set (swig_other_sources)
  foreach (it ${ARGN})
    if (${it} MATCHES ".*\\.i$")
      ot_install_swig_file (${it})
    elseif(${it} MATCHES ".*_doc\\.i\\.in$")
     # handle docstring generation
      set (DOCSTRING_IN_FILE ${CMAKE_CURRENT_SOURCE_DIR}/${it})
      get_filename_component (DOCSTRING_FILE_BASENAME ${DOCSTRING_IN_FILE} NAME_WE)
      add_custom_target (generate_${DOCSTRING_FILE_BASENAME}
                          COMMAND ${CMAKE_COMMAND} -DDOCSTRING_IN_FILE=${DOCSTRING_IN_FILE} -DDOCSTRING_FILE=${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i -P ${CMAKE_SOURCE_DIR}/cmake/escape_backslash_x4.cmake
                          DEPENDS ${DOCSTRING_IN_FILE})
      add_dependencies (generate_docstrings generate_${DOCSTRING_FILE_BASENAME})
      list (APPEND SWIGFILES ${CMAKE_CURRENT_BINARY_DIR}/${DOCSTRING_FILE_BASENAME}.i)
    else ()
      list (APPEND swig_other_sources "${it}")
    endif ()
  endforeach ()

  # workaround for a bug in UseSWIG script not supporting multiple modules and parallel compilation
  # http://www.cmake.org/pipermail/cmake/2011-January/042345.html
  if (CMAKE_VERSION VERSION_LESS 2.8.5)
    set(swig_extra_generated_files)
  endif ()

  swig_add_module (${MODULENAME} python ${SOURCEFILE} ${swig_other_sources})

  add_dependencies (${SWIG_MODULE_${MODULENAME}_REAL_NAME} generate_swig_runtime generate_docstrings)
  swig_link_libraries (${MODULENAME} OT)

  if (LINK_PYTHON_LIBRARY)
    swig_link_libraries (${MODULENAME} ${PYTHON_LIBRARIES})
  endif ()

  set_target_properties (${SWIG_MODULE_${MODULENAME}_REAL_NAME} PROPERTIES NO_SONAME ON)

  if (USE_COTIRE)
    set_target_properties(${SWIG_MODULE_${MODULENAME}_REAL_NAME} PROPERTIES COTIRE_ENABLE_PRECOMPILED_HEADER FALSE)
    cotire (${SWIG_MODULE_${MODULENAME}_REAL_NAME})
    add_dependencies (${SWIG_MODULE_${MODULENAME}_REAL_NAME}_unity generate_swig_runtime generate_docstrings)
    add_dependencies (python_unity ${SWIG_MODULE_${MODULENAME}_REAL_NAME}_unity)
    set_source_files_properties (PythonDistribution.cxx PythonFieldFunction.cxx PROPERTIES COTIRE_EXCLUDED TRUE)
  endif ()

  list (APPEND OPENTURNS_PYTHON_MODULES ${MODULENAME})
endmacro (ot_add_python_module)

install (DIRECTORY openturns DESTINATION ${OPENTURNS_INCLUDE_PATH})

if (LIBXML2_FOUND)
  list (APPEND SWIG_MODULE_common_EXTRA_FLAGS -DOPENTURNS_HAVE_LIBXML2=1)
endif ()
if (MUPARSER_FOUND)
  list (APPEND SWIG_MODULE_func_EXTRA_FLAGS -DOPENTURNS_HAVE_MUPARSER=1)
endif ()

ot_add_python_module(common common_module.i
                      OTtypes.i
                      OTexceptions.i
                      Memory.i
                      TBB.i TBB_doc.i.in
                      Object.i Object_doc.i.in
                      PersistentObject.i PersistentObject_doc.i.in
                      Study.i Study_doc.i.in
                      StorageManager.i StorageManager_doc.i.in
                      XMLStorageManager.i XMLStorageManager_doc.i.in
                      Log.i Log_doc.i.in
                      TTY.i TTY_doc.i.in
                      Path.i Path_doc.i.in
                      Catalog.i
                      ResourceMap.i ResourceMap_doc.i.in
                      ComparisonOperatorImplementation.i
                      ComparisonOperator.i ComparisonOperator_doc.i.in
                      Equal.i Equal_doc.i.in
                      Greater.i Greater_doc.i.in
                      GreaterOrEqual.i GreaterOrEqual_doc.i.in
                      Less.i Less_doc.i.in
                      LessOrEqual.i LessOrEqual_doc.i.in
                      Cache.i
                      PlatformInfo.i PlatformInfo_doc.i.in
                      SharedPointer.i
                      Pointer.i
                      InterfaceObject.i InterfaceObject_doc.i.in
                      TypedInterfaceObject.i
                      TypedCollectionInterfaceObject.i
                      BaseCommonTemplateDefs.i
                   )

ot_add_python_module(typ typ_module.i
                      Collection.i Collection_doc.i.in
                      PersistentCollection.i
                      Description.i Description_doc.i.in
                      Point.i Point_doc.i.in
                      PointWithDescription.i PointWithDescription_doc.i.in
                      DomainImplementation.i DomainImplementation_doc.i.in
                      Interval.i Interval_doc.i.in
                      Indices.i Indices_doc.i.in
                      MatrixImplementation.i
                      Matrix.i Matrix_doc.i.in
                      SquareMatrix.i SquareMatrix_doc.i.in
                      SymmetricMatrix.i SymmetricMatrix_doc.i.in
                      TensorImplementation.i TensorImplementation_doc.i.in
                      Tensor.i Tensor_doc.i.in
                      SymmetricTensor.i SymmetricTensor_doc.i.in
                      ComplexTensorImplementation.i
                      ComplexTensor.i ComplexTensor_doc.i.in
                      ComplexMatrixImplementation.i ComplexMatrixImplementation_doc.i.in
                      ComplexMatrix.i ComplexMatrix_doc.i.in
                      HermitianMatrix.i HermitianMatrix_doc.i.in
                      SquareComplexMatrix.i SquareComplexMatrix_doc.i.in
                      TriangularMatrix.i TriangularMatrix_doc.i.in
                      TriangularComplexMatrix.i TriangularComplexMatrix_doc.i.in
                      CovarianceMatrix.i CovarianceMatrix_doc.i.in
                      CorrelationMatrix.i CorrelationMatrix_doc.i.in
                      IdentityMatrix.i IdentityMatrix_doc.i.in
                      Sample.i Sample_doc.i.in
                      FieldImplementation.i FieldImplementation_doc.i.in
                      Field.i Field_doc.i.in
                      ProcessSample.i ProcessSample_doc.i.in
                      TimeSeries.i TimeSeries_doc.i.in
                      HistoryStrategyImplementation.i HistoryStrategyImplementation_doc.i.in
                      HistoryStrategy.i HistoryStrategy_doc.i.in
                      BaseTypTemplateDefs.i
                   )

ot_add_python_module(statistics statistics_module.i
                      Compact.i Compact_doc.i.in
                      Full.i Full_doc.i.in
                      Last.i Last_doc.i.in
                      Null.i Null_doc.i.in
                      LinearModel.i LinearModel_doc.i.in
                      LinearModelFactory.i LinearModelFactory_doc.i.in
                      TestResult.i TestResult_doc.i.in
                      RandomGenerator.i RandomGenerator_doc.i.in
                      RandomGeneratorState.i RandomGeneratorState_doc.i.in
                      CorrelationAnalysis.i CorrelationAnalysis_doc.i.in
                      LowDiscrepancySequenceImplementation.i LowDiscrepancySequenceImplementation_doc.i.in
                      LowDiscrepancySequence.i LowDiscrepancySequence_doc.i.in
                      SobolSequence.i SobolSequence_doc.i.in
                      FaureSequence.i FaureSequence_doc.i.in
                      HaltonSequence.i HaltonSequence_doc.i.in
                      HaselgroveSequence.i HaselgroveSequence_doc.i.in
                      ReverseHaltonSequence.i ReverseHaltonSequence_doc.i.in
                      SecondOrderModelImplementation.i SecondOrderModelImplementation_doc.i.in
                      SecondOrderModel.i SecondOrderModel_doc.i.in
                      ExponentialCauchy.i ExponentialCauchy_doc.i.in
                      SphericalModel.i SphericalModel_doc.i.in
                      FilteringWindowsImplementation.i FilteringWindowsImplementation_doc.i.in
                      FilteringWindows.i FilteringWindows_doc.i.in
                      Hamming.i Hamming_doc.i.in
                      Hanning.i Hanning_doc.i.in
                      FFTImplementation.i FFTImplementation_doc.i.in
                      FFT.i FFT_doc.i.in
                      SpectralModelImplementation.i SpectralModelImplementation_doc.i.in
                      SpectralModel.i SpectralModel_doc.i.in
                      CovarianceModelImplementation.i CovarianceModelImplementation_doc.i.in
                      CovarianceModel.i CovarianceModel_doc.i.in
                      StationaryCovarianceModel.i 
                      SpectralModelFactoryImplementation.i SpectralModelFactoryImplementation_doc.i.in
                      SpectralModelFactory.i SpectralModelFactory_doc.i.in
                      UserDefinedSpectralModel.i UserDefinedSpectralModel_doc.i.in
                      WelchFactory.i WelchFactory_doc.i.in
                      ExponentialModel.i ExponentialModel_doc.i.in
                      ExponentiallyDampedCosineModel.i ExponentiallyDampedCosineModel_doc.i.in
                      CauchyModel.i CauchyModel_doc.i.in
                      CovarianceModelFactoryImplementation.i CovarianceModelFactoryImplementation_doc.i.in
                      CovarianceModelFactory.i CovarianceModelFactory_doc.i.in
                      UserDefinedCovarianceModel.i UserDefinedCovarianceModel_doc.i.in
                      UserDefinedStationaryCovarianceModel.i UserDefinedStationaryCovarianceModel_doc.i.in
                      StationaryCovarianceModelFactory.i StationaryCovarianceModelFactory_doc.i.in
                      NonStationaryCovarianceModelFactory.i NonStationaryCovarianceModelFactory_doc.i.in
                      SquaredExponential.i SquaredExponential_doc.i.in
                      GeneralizedExponential.i GeneralizedExponential_doc.i.in
                      AbsoluteExponential.i AbsoluteExponential_doc.i.in
                      MaternModel.i MaternModel_doc.i.in
                      DiracCovarianceModel.i DiracCovarianceModel_doc.i.in
                      ProductCovarianceModel.i ProductCovarianceModel_doc.i.in
                      RankMCovarianceModel.i RankMCovarianceModel_doc.i.in
                      TensorizedCovarianceModel.i TensorizedCovarianceModel_doc.i.in
                      HMatrixParameters.i HMatrixParameters_doc.i.in
                      HMatrixFactory.i HMatrixFactory_doc.i.in
                      HMatrix.i HMatrix_doc.i.in
                      HMatrixImplementation.i HMatrixImplementation_doc.i.in
                      BaseStatisticsTemplateDefs.i
                   )

ot_add_python_module(geom geom_module.i
                      Domain.i Domain_doc.i.in
                      BipartiteGraph.i BipartiteGraph_doc.i.in
                      Mesh.i Mesh_doc.i.in
                      RegularGrid.i RegularGrid_doc.i.in

=== python/test/CMakeLists.txt ===
#                                               -*- cmake -*-

set (ADAPT_CHECK_TESTS_EXPONENT)
set (REPLACE_EOL " | cat ")
if (MINGW)
  # replace dos eols
  set (REPLACE_EOL " | tr -d '\\\\015' ")
  # By default, Mingw-g++ puts 3 digits to real exponent whereas g++ puts 2.
  set (ADAPT_CHECK_TESTS_EXPONENT "PRINTF_EXPONENT_DIGITS=2")
endif ()


set (PYINSTALLCHECK_ENVIRONMENT "OPENTURNS_CONFIG_PATH=${INSTALL_DESTDIR}${SYSCONFIG_PATH}/openturns"
                                 "PYTHONPATH=${INSTALL_DESTDIR}${PYTHON_MODULE_PATH}${PATH_SEP}$ENV{PYTHONPATH}"
                                 ${ADAPT_CHECK_TESTS_EXPONENT}
   )

# This macro compiles on the fly and run the corresponding post-installation test
# It can have two optional arguments PRE and POST followed by some shell command to be run
# before or after the test if needed
# PRE and POST options cn be repeated many times: the arguments will be run one after the other
# in the order of appearence. If one fails, the whole command fails.
macro (ot_pyinstallcheck_test TESTNAME)
  set (TESTNAME_TGT t_${TESTNAME})
  set (TESTNAME_SRC ${TESTNAME_TGT}.py)
  set (TESTNAME_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_SRC})
  set (_CMD)
  set (_PRE)
  set (_POST)
  set (_PARAMS)
  set (_IGNOREOUT OFF)
  foreach (_ARG ${ARGN})
    string (TOUPPER ${_ARG} ARG)
    if (${ARG} MATCHES PRE)
      set (_CMD PRE)
    elseif (${ARG} MATCHES POST)
      set (_CMD POST)
    elseif (${ARG} MATCHES PARAMS)
      set (_CMD PARAMS)
    elseif (${ARG} MATCHES IGNOREOUT)
      set (_IGNOREOUT ON)
    else (${ARG} MATCHES PRE)
      if (${_CMD} MATCHES PRE)
        set (_PRE "${_PRE} ${_ARG} && ")
      elseif (${_CMD} MATCHES POST)
        set (_POST "${_POST} && ${_ARG}")
      elseif (${_CMD} MATCHES PARAMS)
        set (_PARAMS "${_PARAMS} ${_ARG}")
      endif  (${_CMD} MATCHES PRE)
      set (_CMD)
    endif (${ARG} MATCHES PRE)
  endforeach (_ARG)

  if (_IGNOREOUT)
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} > /dev/null)")
  else (_IGNOREOUT)
    set (TESTNAME_OUT ${TESTNAME_TGT}.expout)
    get_source_file_property (OUTFILE_LOC ${TESTNAME_OUT} LOCATION)
    set (OUTFILE_LOC ${CMAKE_CURRENT_SOURCE_DIR}/${TESTNAME_OUT})
    set (COMMAND "(${PYTHON_EXECUTABLE} ${TESTNAME_LOC} ${_PARAMS} ${REPLACE_EOL} > ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out) && diff -u ${OUTFILE_LOC} ${CMAKE_CURRENT_BINARY_DIR}/${TESTNAME_TGT}.out")
  endif (_IGNOREOUT)

  if (_PRE OR _POST)
    set (COMMAND "${_PRE}${COMMAND}${_POST}")
  endif (_PRE OR _POST)

  add_test (pyinstallcheck_${TESTNAME} "sh" "-c" "${COMMAND}")

  set_tests_properties (pyinstallcheck_${TESTNAME} PROPERTIES ENVIRONMENT "${PYINSTALLCHECK_ENVIRONMENT}")
  install (FILES ${TESTNAME_SRC}
            DESTINATION ${EXAMPLE_PATH}
            PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE
         )
endmacro (ot_pyinstallcheck_test)


## Python post-installation tests

# Common
if (LIBXML2_FOUND)
  ot_pyinstallcheck_test (Object_pickle)
endif ()
ot_pyinstallcheck_test (ComparisonOperator_std)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (Study_saveload)
endif ()
ot_pyinstallcheck_test (Path_std IGNOREOUT)
ot_pyinstallcheck_test (ResourceMap_std IGNOREOUT)
ot_pyinstallcheck_test (Catalog_std IGNOREOUT)

# Type
ot_pyinstallcheck_test (Collection_std)
ot_pyinstallcheck_test (Description_std)
ot_pyinstallcheck_test (Indices_std)
ot_pyinstallcheck_test (Point_std)
ot_pyinstallcheck_test (Point_description)
ot_pyinstallcheck_test (Matrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_lapack)
ot_pyinstallcheck_test (SquareMatrix_std)
ot_pyinstallcheck_test (TriangularMatrix_std)
ot_pyinstallcheck_test (SymmetricMatrix_std)
ot_pyinstallcheck_test (Tensor_std)
ot_pyinstallcheck_test (ComplexTensor_std)
ot_pyinstallcheck_test (SymmetricTensor_std)
ot_pyinstallcheck_test (Matrix_solve)
ot_pyinstallcheck_test (Matrix_decomposition)
ot_pyinstallcheck_test (IdentityMatrix_std)
ot_pyinstallcheck_test (RegularGrid_std)
ot_pyinstallcheck_test (ComplexMatrix_std)
ot_pyinstallcheck_test (SquareComplexMatrix_std)
ot_pyinstallcheck_test (HermitianMatrix_std)
ot_pyinstallcheck_test (TriangularComplexMatrix_std)
ot_pyinstallcheck_test (Matrix_slice)
ot_pyinstallcheck_test (Matrix_operators)
if (NUMPY_FOUND)
  ot_pyinstallcheck_test (Matrix_numpy)
endif ()

# Func
ot_pyinstallcheck_test (SpecFunc_std)
ot_pyinstallcheck_test (Function_std)
ot_pyinstallcheck_test (ComposedFunction_std)
ot_pyinstallcheck_test (Function_python)
if (LIBXML2_FOUND)
ot_pyinstallcheck_test (Function_python_saveload)
endif ()
ot_pyinstallcheck_test (DatabaseFunction_std)
ot_pyinstallcheck_test (Function_operations)
ot_pyinstallcheck_test (ParametricFunction_std)

if (R_base_FOUND)
ot_pyinstallcheck_test (Function_draw)
endif ()
ot_pyinstallcheck_test (Function_history)
ot_pyinstallcheck_test (AggregatedEvaluation_std)
ot_pyinstallcheck_test (SymbolicEvaluation_std)
ot_pyinstallcheck_test (SymbolicGradient_std)
ot_pyinstallcheck_test (SymbolicHessian_std)
ot_pyinstallcheck_test (LinearFunction_std)
ot_pyinstallcheck_test (LinearEvaluation_std)
ot_pyinstallcheck_test (LinearCombinationEvaluation_std)
ot_pyinstallcheck_test (LinearCombinationGradient_std)
ot_pyinstallcheck_test (LinearCombinationHessian_std)
ot_pyinstallcheck_test (PiecewiseLinearEvaluation_std)
ot_pyinstallcheck_test (PiecewiseHermiteEvaluation_std)
ot_pyinstallcheck_test (QuadraticFunction_std)
ot_pyinstallcheck_test (QuadraticEvaluation_std)
ot_pyinstallcheck_test (LinearGradient_std)
ot_pyinstallcheck_test (AggregatedFunction_std)
ot_pyinstallcheck_test (SymbolicFunction_std)
ot_pyinstallcheck_test (DualLinearCombinationFunction_std)
ot_pyinstallcheck_test (IndicatorFunction_std)
ot_pyinstallcheck_test (LinearCombinationFunction_std)
ot_pyinstallcheck_test (ConstantGradient_std)
ot_pyinstallcheck_test (ConstantHessian_std)
ot_pyinstallcheck_test (Basis_std)
ot_pyinstallcheck_test (BasisSequence_std)
ot_pyinstallcheck_test (LARS_std)
ot_pyinstallcheck_test (FieldFunction_std)
ot_pyinstallcheck_test (ValueFunction_std)
ot_pyinstallcheck_test (VertexValueFunction_std)
ot_pyinstallcheck_test (BoxCoxEvaluation_std)
ot_pyinstallcheck_test (BoxCoxTransform_std)
ot_pyinstallcheck_test (InverseBoxCoxEvaluation_std)
ot_pyinstallcheck_test (InverseBoxCoxTransform_std)
ot_pyinstallcheck_test (TrendEvaluation_std)
ot_pyinstallcheck_test (TrendTransform_std)
ot_pyinstallcheck_test (InverseTrendEvaluation_std)
ot_pyinstallcheck_test (InverseTrendTransform_std)
ot_pyinstallcheck_test (ExpertMixture_std)
ot_pyinstallcheck_test (UniVariatePolynomial_std)
ot_pyinstallcheck_test (BasisFactory_std)
ot_pyinstallcheck_test (Field_std)
ot_pyinstallcheck_test (MonomialFunction_std)
ot_pyinstallcheck_test (MonomialFunctionFactory_std)
ot_pyinstallcheck_test (TensorizedUniVariateFunctionFactory_std)

# Stat
ot_pyinstallcheck_test (Sample_std)
ot_pyinstallcheck_test (Sample_computation)
ot_pyinstallcheck_test (Sample_slice)
ot_pyinstallcheck_test (Sample_split)
ot_pyinstallcheck_test (Sample_large)
ot_pyinstallcheck_test (Sample_bug14)
ot_pyinstallcheck_test (Sample_csv)
ot_pyinstallcheck_test (Sample_operators)
ot_pyinstallcheck_test (HistoryStrategy_std)
ot_pyinstallcheck_test (CovarianceMatrixLapack_std)
ot_pyinstallcheck_test (CorrelationMatrix_std)
if (R_rot_FOUND)
ot_pyinstallcheck_test (LinearModel_std)
ot_pyinstallcheck_test (LinearModelFactory_std)
endif ()
ot_pyinstallcheck_test (Field_draw)
ot_pyinstallcheck_test (ProcessSample_std)
ot_pyinstallcheck_test (RandomGenerator_std)
ot_pyinstallcheck_test (SobolSequence_std)
ot_pyinstallcheck_test (FaureSequence_std)
ot_pyinstallcheck_test (HaltonSequence_std)
ot_pyinstallcheck_test (HaselgroveSequence_std)
ot_pyinstallcheck_test (ReverseHaltonSequence_std)
ot_pyinstallcheck_test (TestResult_std)
ot_pyinstallcheck_test (CorrelationAnalysis_std)
ot_pyinstallcheck_test (TimeSeries_std)
ot_pyinstallcheck_test (ExponentialCauchy_std)
ot_pyinstallcheck_test (FilteringWindows_std)
ot_pyinstallcheck_test (WelchFactory_std)
ot_pyinstallcheck_test (ExponentialModel_std)
ot_pyinstallcheck_test (CovarianceModel_std)
ot_pyinstallcheck_test (ExponentiallyDampedCosineModel_std)
ot_pyinstallcheck_test (CauchyModel_std)
ot_pyinstallcheck_test (SecondOrderModel_std)
ot_pyinstallcheck_test (UserDefinedSpectralModel_std)
ot_pyinstallcheck_test (UserDefinedCovarianceModel_std)
ot_pyinstallcheck_test (UserDefinedStationaryCovarianceModel_std)
ot_pyinstallcheck_test (StationaryCovarianceModelFactory_std)
ot_pyinstallcheck_test (NonStationaryCovarianceModelFactory_std)
if (HMAT_FOUND)
ot_pyinstallcheck_test (HMatrix_std)
endif ()

# Geom
ot_pyinstallcheck_test (Domain_std)
ot_pyinstallcheck_test (Interval_std)
ot_pyinstallcheck_test (IntervalMesher_std)
ot_pyinstallcheck_test (LevelSet_std)
ot_pyinstallcheck_test (LevelSetMesher_std)
ot_pyinstallcheck_test (Mesh_std)

## Graph
if (R_base_FOUND)
ot_pyinstallcheck_test (BarPlot_std)
ot_pyinstallcheck_test (Cloud_std)
ot_pyinstallcheck_test (Contour_std)
ot_pyinstallcheck_test (Curve_std)
ot_pyinstallcheck_test (Drawable_std)
ot_pyinstallcheck_test (Graph_export)
ot_pyinstallcheck_test (Graph_mix)
ot_pyinstallcheck_test (Pairs_std)
ot_pyinstallcheck_test (Pie_std)
ot_pyinstallcheck_test (Polygon_std)
ot_pyinstallcheck_test (PolygonArray_std)
ot_pyinstallcheck_test (Staircase_std)
ot_pyinstallcheck_test (Text_std)
endif ()

## Diff
ot_pyinstallcheck_test (FiniteDifferenceStep_std)
ot_pyinstallcheck_test (CenteredFiniteDifferenceGradient_std)
ot_pyinstallcheck_test (CenteredFiniteDifferenceHessian_std)
ot_pyinstallcheck_test (NonCenteredFiniteDifferenceGradient_std)

## Optim
ot_pyinstallcheck_test (AbdoRackwitz_std)
ot_pyinstallcheck_test (Cobyla_std)
ot_pyinstallcheck_test (SQP_std)
ot_pyinstallcheck_test (TNC_std)
ot_pyinstallcheck_test (NearestPointChecker_std)
if (NLOPT_FOUND)
  ot_pyinstallcheck_test (NLopt_std)
endif ()
ot_pyinstallcheck_test (MultiStart_std)
ot_pyinstallcheck_test (EfficientGlobalOptimization_std)

## Solver
ot_pyinstallcheck_test (Brent_std)
ot_pyinstallcheck_test (Bisection_std)
ot_pyinstallcheck_test (Secant_std)
ot_pyinstallcheck_test (RungeKutta_std)

# Algo
ot_pyinstallcheck_test (PenalizedLeastSquaresAlgorithm_std)
ot_pyinstallcheck_test (KFold_std)
ot_pyinstallcheck_test (CorrectedLeaveOneOut_std)
ot_pyinstallcheck_test (KDTree_std)
ot_pyinstallcheck_test (LeastSquaresMetaModelSelectionFactory_std)
ot_pyinstallcheck_test (KissFFT_std)
ot_pyinstallcheck_test (GaussKronrod_std)
ot_pyinstallcheck_test (GaussLegendre_std)
ot_pyinstallcheck_test (IteratedQuadrature_std)
ot_pyinstallcheck_test (KarhunenLoeveP1Factory_std)
ot_pyinstallcheck_test (DesignProxy_std)
ot_pyinstallcheck_test (LeastSquaresMethod_std)
ot_pyinstallcheck_test (KarhunenLoeveP1Algorithm_std)
ot_pyinstallcheck_test (KarhunenLoeveSVDAlgorithm_std)

## Model
ot_pyinstallcheck_test (Event_std)
ot_pyinstallcheck_test (StandardEvent_std)
ot_pyinstallcheck_test (Event_domain)
ot_pyinstallcheck_test (RandomVector_constant)
ot_pyinstallcheck_test (RandomVector_distribution)
ot_pyinstallcheck_test (RandomVector_composite)
ot_pyinstallcheck_test (RandomVector_conditional)
ot_pyinstallcheck_test (RandomVector_python)

## Process
ot_pyinstallcheck_test (WhiteNoise_std)
ot_pyinstallcheck_test (RandomWalk_std)
ot_pyinstallcheck_test (ARMAState_std)
ot_pyinstallcheck_test (ARMACoefficients_std)
ot_pyinstallcheck_test (ARMA_std)
ot_pyinstallcheck_test (GaussianProcess_std)
ot_pyinstallcheck_test (SpectralGaussianProcess_std)
ot_pyinstallcheck_test (CompositeProcess_std)
ot_pyinstallcheck_test (ARMALikelihoodFactory_std)
ot_pyinstallcheck_test (FunctionalBasisProcess_std)
ot_pyinstallcheck_test (WhittleFactory_std)
ot_pyinstallcheck_test (ConditionedNormalProcess_std)
ot_pyinstallcheck_test (KarhunenLoeveQuadratureFactory_std)
ot_pyinstallcheck_test (KarhunenLoeveQuadratureAlgorithm_std)

## Transformation

=== validation/src/CMakeLists.txt ===
#                                               -*- cmake -*-

install (FILES
          ValidSolveLinearSystemRect.sce
          AbdoRackwitz.txt
          Cas1_eads.txt
          Cas1.txt
          Cas2.txt
          Cas3_eads.txt
          Cas4.txt
          Cas5.txt
          Cas6.txt
          Cas7_eads.txt
          CoefficientOfVariation.txt
          Curvature.txt
          Debye.txt
          DefaultDistribution.txt
          DirectionalSampling.txt
          dProb.txt
          equality_constrained_quadratic_quadratic.txt
          GeneralizedNataf.txt
          IntegrationND.txt
          InverseErf.txt
          lambda_U.txt
          LambertW.txt
          NonCentralStudent.txt
          PSORM.txt
          qnorm.txt
          Sensibilite_ref1.txt
          Sensibilite_ref2.txt
          Sensibilite_ref3.txt
          SensibiliteValidBeta.txt
          SinhTanh.txt
          Student2D.txt
          ti.txt
          truncnorm.txt
          ValidAbdoMixture.txt
          ValidAndersonDarling.txt
          ValidBeta.txt
          ValidBoundConstrainedAlgoithm.txt
          ValidChiSquare.txt
          ValidClaytonCopula.txt
          ValidConditionalArchimedean.txt
          ValidCovarianceAlgorithm.txt
          ValidCovarianceGauss.txt
          ValidCovarianceMatrixLapack.sce
          ValidCovariance.txt
          ValidCramerVonMises.txt
          ValidDiff.txt
          ValidDistFunc.txt
          ValidDistribution.txt
          ValidElliptical.txt
          validElliptical.sce
          validEnumerate.txt
          ValidEpanechnikov.txt
          ValidEstimatedTruncatedNormal.txt
          ValidEstimateLogistic.txt
          ValidEstimate.txt
          ValidExponential.txt
          ValidFORMKernelMixture.txt
          ValidFrankCopula.txt
          ValidGammaEstimate.txt
          ValidGamma.txt
          ValidGeometric.txt
          ValidGumbelCopula.txt
          ValidGumbelEstimate.txt
          ValidGumbel.txt
          ValidHisto.txt
          ValidIndependentCopula.txt
          ValidInverseIsoprobabilisticTransformationEllipticalCopula.txt
          ValidInverseNatafCopula2.txt
          ValidInverseNatafCopula.txt
          ValidIsoProbabilisicTransformationEllipticalCopula.txt
          ValidLeastSquareAlgorithm.txt
          ValidLinearCombination.txt
          ValidLaplace.txt
          ValidLogistic.txt
          ValidLogNormal.txt
          ValidMultiNomial.txt
          ValidMultiStudent.txt
          ValidNatafEllipticalcopula.txt
          ValidNormal1.txt
          ValidNormalCopula.txt
          ValidNumericalSample.R
          ValidOrthogonalProductFactory.txt
          ValidOrthogonalUniVariateFactory.txt
          ValidPoisson.txt
          ValidPoutreArticle.txt
          ValidProductFunction.txt
          ValidSampleComputation.sce
          ValidQuadraticFunction.txt
          ValidQuadraticTaylor.txt
          ValidRayleigh.txt
          valid_SORM.txt
          ValidSpecFunc.txt
          ValidStudentEstimate.txt
          ValidStudent.txt
          ValidTriangular.txt
          ValidTruncatedNormalFactory.txt
          ValidTruncatedNormal.txt
          ValidUniform.txt
          ValidUniVariatePolynomial.txt
          ValidWeibull.txt
          ValidWilks.txt
          Variance.txt
          Weibull_moment.txt
          ziggurat_exponential.txt
          ziggurat_exponential.mws
          ziggurat_normal.txt
          ziggurat_normal.mws
          ValidZipfMandelbrot.mw
          DESTINATION ${OPENTURNS_VALIDATION_PATH}
       )

=== lib/src/Base/Algo/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (ApproximationAlgorithmImplementation.cxx)
ot_add_source_file (ApproximationAlgorithm.cxx)
ot_add_source_file (ApproximationAlgorithmImplementationFactory.cxx)
ot_add_source_file (ClassifierImplementation.cxx)
ot_add_source_file (Classifier.cxx)
ot_add_source_file (FittingAlgorithmImplementation.cxx)
ot_add_source_file (FittingAlgorithm.cxx)
ot_add_source_file (CorrectedLeaveOneOut.cxx)
ot_add_source_file (KDTree.cxx)
ot_add_source_file (KFold.cxx)
ot_add_source_file (LeastSquaresMetaModelSelection.cxx)
ot_add_source_file (LeastSquaresMetaModelSelectionFactory.cxx)
ot_add_source_file (PenalizedLeastSquaresAlgorithm.cxx)
ot_add_source_file (PenalizedLeastSquaresAlgorithmFactory.cxx)
ot_add_source_file (FFTImplementation.cxx)
ot_add_source_file (FFT.cxx)
ot_add_source_file (KissFFT.cxx)
ot_add_source_file (IntegrationAlgorithmImplementation.cxx)
ot_add_source_file (IntegrationAlgorithm.cxx)
ot_add_source_file (GaussKronrod.cxx)
ot_add_source_file (GaussKronrodRule.cxx)
ot_add_source_file (GaussLegendre.cxx)
ot_add_source_file (IteratedQuadrature.cxx)
ot_add_source_file (DesignProxy.cxx)
ot_add_source_file (LeastSquaresMethodImplementation.cxx)
ot_add_source_file (LeastSquaresMethod.cxx)
ot_add_source_file (QRMethod.cxx)
ot_add_source_file (SVDMethod.cxx)
ot_add_source_file (CholeskyMethod.cxx)
ot_add_source_file (SparseMethod.cxx)
ot_add_source_file (KarhunenLoeveResultImplementation.cxx)
ot_add_source_file (KarhunenLoeveResult.cxx)
ot_add_source_file (KarhunenLoeveAlgorithmImplementation.cxx)
ot_add_source_file (KarhunenLoeveAlgorithm.cxx)
ot_add_source_file (KarhunenLoeveP1Factory.cxx)
ot_add_source_file (KarhunenLoeveP1Algorithm.cxx)
ot_add_source_file (KarhunenLoeveSVDAlgorithm.cxx)

ot_install_header_file (OTAlgo.hxx)
ot_install_header_file (ApproximationAlgorithmImplementation.hxx)
ot_install_header_file (ApproximationAlgorithm.hxx)
ot_install_header_file (ApproximationAlgorithmImplementationFactory.hxx)
ot_install_header_file (ClassifierImplementation.hxx)
ot_install_header_file (Classifier.hxx)
ot_install_header_file (FittingAlgorithmImplementation.hxx)
ot_install_header_file (FittingAlgorithm.hxx)
ot_install_header_file (CorrectedLeaveOneOut.hxx)
ot_install_header_file (KDTree.hxx)
ot_install_header_file (KFold.hxx)
ot_install_header_file (LeastSquaresMetaModelSelection.hxx)
ot_install_header_file (LeastSquaresMetaModelSelectionFactory.hxx)
ot_install_header_file (PenalizedLeastSquaresAlgorithm.hxx)
ot_install_header_file (PenalizedLeastSquaresAlgorithmFactory.hxx)
ot_install_header_file (FFTImplementation.hxx)
ot_install_header_file (FFT.hxx)
ot_install_header_file (KissFFT.hxx)
# ot_install_header_file (kissfft.hh)
ot_install_header_file (IntegrationAlgorithmImplementation.hxx)
ot_install_header_file (IntegrationAlgorithm.hxx)
ot_install_header_file (GaussKronrod.hxx)
ot_install_header_file (GaussKronrodRule.hxx)
ot_install_header_file (GaussLegendre.hxx)
ot_install_header_file (IteratedQuadrature.hxx)
ot_install_header_file (DesignProxy.hxx)
ot_install_header_file (LeastSquaresMethodImplementation.hxx)
ot_install_header_file (LeastSquaresMethod.hxx)
ot_install_header_file (QRMethod.hxx)
ot_install_header_file (SVDMethod.hxx)
ot_install_header_file (CholeskyMethod.hxx)
ot_install_header_file (SparseMethod.hxx)
ot_install_header_file (KarhunenLoeveResultImplementation.hxx)
ot_install_header_file (KarhunenLoeveResult.hxx)
ot_install_header_file (KarhunenLoeveAlgorithmImplementation.hxx)
ot_install_header_file (KarhunenLoeveAlgorithm.hxx)
ot_install_header_file (KarhunenLoeveP1Factory.hxx)
ot_install_header_file (KarhunenLoeveP1Algorithm.hxx)
ot_install_header_file (KarhunenLoeveSVDAlgorithm.hxx)

=== lib/src/Base/Common/CMakeLists.txt ===
#                                               -*- cmake -*-

# Register current directory files
ot_add_current_dir_to_include_dirs ()

ot_add_source_file (Memory.cxx)
ot_add_source_file (OSS.cxx)
ot_add_source_file (PlatformInfo.cxx)
ot_add_source_file (AtomicFunctions.cxx)
ot_add_source_file (Object.cxx)
ot_add_source_file (PersistentObject.cxx)
ot_add_source_file (IdFactory.cxx)
ot_add_source_file (Catalog.cxx)
ot_add_source_file (Exception.cxx)
ot_add_source_file (InterfaceObject.cxx)
ot_add_source_file (Lockable.cxx)
ot_add_source_file (StorageManager.cxx)
ot_add_source_file (Os.cxx)
ot_add_source_file (Path.cxx)
ot_add_source_file (ComparisonOperator.cxx)
ot_add_source_file (ComparisonOperatorImplementation.cxx)
ot_add_source_file (OStream.cxx)
ot_add_source_file (Less.cxx)
ot_add_source_file (LessOrEqual.cxx)
ot_add_source_file (Equal.cxx)
ot_add_source_file (Greater.cxx)
ot_add_source_file (GreaterOrEqual.cxx)
ot_add_source_file (ResourceMap.cxx)
ot_add_source_file (Log.cxx)
ot_add_source_file (TTY.cxx)
ot_add_source_file (TBB.cxx)
ot_add_source_file (Study.cxx)

if (LIBXML2_FOUND)
  ot_add_source_file (XMLStorageManager.cxx)
  ot_add_source_file (XMLToolbox.cxx)
endif (LIBXML2_FOUND)

ot_install_header_file (Greater.hxx)
ot_install_header_file (ResourceMap.hxx)
ot_install_header_file (ComparisonOperatorImplementation.hxx)
ot_install_header_file (OStream.hxx)
ot_install_header_file (SharedPointer.hxx)
ot_install_header_file (StorageManager.hxx)
ot_install_header_file (OSS.hxx)
ot_install_header_file (Study.hxx)
ot_install_header_file (Less.hxx)
ot_install_header_file (PersistentObject.hxx)
ot_install_header_file (PlatformInfo.hxx)
ot_install_header_file (AtomicFunctions.hxx)
ot_install_header_file (MutexLock.hxx)
ot_install_header_file (Equal.hxx)
ot_install_header_file (Pointer.hxx)
ot_install_header_file (IdFactory.hxx)
ot_install_header_file (Memory.hxx)
ot_install_header_file (PersistentObjectFactory.hxx)
ot_install_header_file (Lockable.hxx)
ot_install_header_file (ComparisonOperator.hxx)
ot_install_header_file (TypedInterfaceObject.hxx)
ot_install_header_file (InterfaceObject.hxx)
ot_install_header_file (OTCommon.hxx)
ot_install_header_file (Catalog.hxx)
ot_install_header_file (GreaterOrEqual.hxx)
ot_install_header_file (Log.hxx)
ot_install_header_file (TBB.hxx)
ot_install_header_file (TypedCollectionInterfaceObject.hxx)
ot_install_header_file (Os.hxx)
ot_install_header_file (Object.hxx)
ot_install_header_file (LessOrEqual.hxx)
ot_install_header_file (Exception.hxx)
ot_install_header_file (Path.hxx)
ot_install_header_file (TTY.hxx)

ot_install_header_file (XMLToolbox.hxx)
ot_install_header_file (XMLchar_traits.hxx)
if (LIBXML2_FOUND)
  ot_install_header_file (XMLStorageManager.hxx)
endif (LIBXML2_FOUND)

=== debian/changelog ===
openturns (1.9-5) unstable; urgency=medium

  * debian/patches/discard-levelsetmesher-test.patch:  This test fails
    on many non-Intel ports, discard it for now.

 -- Denis Barbier <barbier@debian.org>  Mon, 20 Nov 2017 00:25:04 +0100

openturns (1.9-4) unstable; urgency=medium

  * Upload into unstable
  * This version builds with Python 3.6 without change. Closes: #881706

 -- Denis Barbier <barbier@debian.org>  Sun, 19 Nov 2017 16:53:02 +0100

openturns (1.9-3) experimental; urgency=medium

  * debian/copyright: Minor updates
  * debian/rules: use SOURCE_DATE_EPOCH for reproducible builds
  * debian/libopenturns-dev.install: Do not install openturns-config,
    this script is obsolete.

 -- Denis Barbier <barbier@debian.org>  Fri, 25 Aug 2017 23:23:45 +0200

openturns (1.9-2) experimental; urgency=medium

  * debian/control: Remove Christophe from Uploaders.
    Closes: #835009
  * debian/rules: Fix test failure on *-i386.
    Closes: #871505
    Report by Matthias Klose and patch by Steve Langasek, thanks.
  * debian/control: Build-Depends on g++ (>= 4:7)
    Closes: #871298
    Report and patch by James Cowgill, thanks.
  * debian/control: Bump Standards-Version to 4.1.0, no changes needed.
  * debian/control: Build-Depends on dh-python.
  * debian/control: Remove python-openturns-dev package.
  * debian/control debian/compat: Bump debhelper compat level to 10.

 -- Denis Barbier <barbier@debian.org>  Tue, 22 Aug 2017 21:50:32 +0200

openturns (1.9-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream release.

 -- Denis Barbier <barbier@debian.org>  Tue, 18 Apr 2017 18:14:47 +0200

openturns (1.9~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Mon, 03 Apr 2017 18:14:47 +0200

openturns (1.8-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream release.

 -- Denis Barbier <barbier@debian.org>  Thu, 16 Nov 2016 18:14:47 +0100

openturns (1.8~rc2-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Thu, 03 Nov 2016 18:14:47 +0100

openturns (1.8~rc1-1) experimental; urgency=low

  [ Julien Schueller ]
  * New upstream pre-release.

 -- Denis Barbier <barbier@debian.org>  Thu, 30 Jun 2016 18:14:47 +0200

=== debian/control ===
Source: openturns
Section: science
Priority: extra
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Denis Barbier <barbier@debian.org>
Build-Depends: debhelper (>= 10), dh-python, quilt, gfortran, g++ (>= 4:7),
 bison, flex, cmake, bc,
 libmuparser-dev, libxml2-dev, liblapack-dev, libblas-dev,
 libboost-math-dev, libhmat-oss-dev, libnlopt-dev,
 libtbb-dev [i386 amd64 ia64],
 r-base-core, python-dev, python3-dev, swig (>= 2.0.9)
Standards-Version: 4.1.0
Homepage: http://www.openturns.org/
Vcs-Browser: https://anonscm.debian.org/git/debian-science/packages/openturns.git
Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/openturns.git
X-Python-Version: current
X-Python3-Version: current

Package: libopenturns0.10
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: python-openturns, r-base-core, ghostscript, r-other-rot (= ${binary:Version})
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: dynamic libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * define the outputs of interest and decision criteria;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the dynamic libraries.
 .
 The library implements almost all the treatments of uncertainty that
 OpenTURNS can provide. It is designed to be linked against any user
 specific application, or with either the textual front-end (see
 python-openturns or python3-openturns packages).
 .
 The main function of that library is giving to specific applications
 all the functionalities needed to treat uncertainties in
 studies. Targeted users are all engineers who want to introduce the
 probabilistic dimension in their so far deterministic studies.

Package: libopenturns-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libopenturns0.10 (= ${binary:Version}),
  libmuparser-dev, libxml2-dev, liblapack-dev, libblas-dev, libtbb-dev [i386 amd64 ia64], libhmat-oss-dev, libnlopt-dev
Replaces: python-openturns-dev (<< 1.5-2)
Breaks: python-openturns-dev (<< 1.5-2)
Description: headers and development libraries for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the OpenTURNS headers should be used if one
 wants to link its application against the library.

Package: libopenturns0.10-dbg
Section: debug
Architecture: any
Depends: libopenturns0.10 (= ${binary:Version}), ${misc:Depends}
Description: debug symbols for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides the debug symbols of the OpenTurns libraries to
 help with debugging either your applications or OpenTURNS

Package: python-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenturns0.10 (= ${binary:Version}), ${python:Depends}
Provides: ${python:Provides}
Suggests: python-matplotlib, python-scipy
Description: Python front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides a textual user interface that gives access to
 all the functionalities provided by the OpenTURNS library.

Package: python3-openturns
Section: python
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libopenturns0.10 (= ${binary:Version}), ${python3:Depends}
Provides: ${python3:Provides}
Suggests: python3-matplotlib, python3-scipy
Description: Python3 front-end of OpenTURNS (aka TUI)
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides a textual user interface with Python3 that gives
 access to all the functionalities provided by the OpenTURNS library.

Package: r-other-rot
Section: gnu-r
Architecture: any
Depends: ${misc:Depends}, r-base-core
Description: GNU R package of few tools needed by OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides R files needed by some OpenTURNS objects.

Package: openturns-examples
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python, python-openturns (= ${binary:Version}), libopenturns-dev
Replaces: openturns-wrapper
Breaks: openturns-wrapper
Description: examples of OpenTURNS functionalities
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package provides examples which are written either in C++ or in
 Python.
 .
 They are primarly used as validation tests for the whole
 platform but they can also be seen as tutorials for
 beginners.

Package: openturns-validation
Section: science
Architecture: all
Depends: ${misc:Depends}
Description: validation files for OpenTURNS
 OpenTURNS is a powerful and generic tool to treat and quantify
 uncertainties in numerical simulations in design, optimization and
 control. It allows both sensitivity and reliability analysis studies:
  * defining the outputs of interest and decision criterion;
  * quantify and model the source of uncertainties;
  * propagate uncertainties and/or analyse sensitivity and
  * rank the sources of uncertainty
 .
 OpenTURNS is a large project with more than 300 C++ classes which
 uses well known and supported software such as R for the statistical
 methods and BLAS/LAPACK for the linear algebra.
 .
 This package includes many maple input files that validates the
 results and the algorithms of OpenTURNS in a mathematical sense.

=== debian/rules ===
#!/usr/bin/make -f

ifeq ($(findstring parallel=,$(DEB_BUILD_OPTIONS)),)
	export DEB_BUILD_OPTIONS+=parallel=$(shell getconf _NPROCESSORS_ONLN)
endif
$(info DEB_BUILD_OPTIONS:$(origin DEB_BUILD_OPTIONS)=$(DEB_BUILD_OPTIONS))

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	test_makeflags = -j$(NUMJOBS)
endif

cppflags := $(shell dpkg-buildflags --get CPPFLAGS)
cflags := $(shell dpkg-buildflags --get CFLAGS) $(cppflags)
cxxflags := $(shell dpkg-buildflags --get CXXFLAGS) $(cppflags)
fflags := $(shell dpkg-buildflags --get FFLAGS)
ldflags := $(shell dpkg-buildflags --get LDFLAGS)
ldflags += -Wl,--as-needed

ifeq ($(shell dpkg --print-architecture),armel)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifeq ($(shell dpkg --print-architecture),armhf)
    cflags := $(subst -O2,-O1,$(cflags))
    cxxflags := $(subst -O2,-O1,$(cxxflags))
    fflags := $(subst -O2,-O1,$(fflags))
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 kfreebsd-i386 hurd-i386))
    cflags += -O0 -ffloat-store
    cxxflags += -ffloat-store
endif
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), i386 amd64 ia64))
    with_tbb := -DUSE_TBB:BOOL=ON
else
    with_tbb := -DUSE_TBB:BOOL=OFF
endif

debRlib := $(CURDIR)/debian/tmp/usr/lib/R/site-library
export R_LIBS=$(debRlib)
PYVER = $(shell pyversions -d)
PY3VER = $(shell py3versions -d)
PYALL = $(PYVER) $(PY3VER)

BUILD_DATE = $(shell date --utc --date="@$(SOURCE_DATE_EPOCH)" "+%a, %d %b %Y %H:%M:%S %z")

%:
ifneq (,$(findstring $(shell dpkg-architecture -qDEB_HOST_ARCH), mips mipsel))
	$(error This package requires more than 1GB RAM; do not build on mips/mipsel)
endif
	dh $@ --buildsystem=cmake --with python2,python3 --with quilt --parallel

debian/tmp/usr/lib/R/site-library/rot:
	-mkdir -p $(debRlib)
	R CMD INSTALL --library=$(debRlib) --built-timestamp='$(BUILD_DATE)' utils/rot_1.4.6.tar.gz

override_dh_auto_configure: debian/tmp/usr/lib/R/site-library/rot $(PYALL:python%=cmake-configure-%) \

cmake-configure-%:
	dh_auto_configure -Bbuild-python$* -- \
            $(with_tbb) \
            -Dot_configure_date:STRING='$(BUILD_DATE)' \
            -DUSE_SPHINX:BOOL=OFF \
            -DCMAKE_CXX_COMPILER:FILEPATH=/usr/bin/g++ \
            -DCMAKE_C_COMPILER:FILEPATH=/usr/bin/gcc \
            -DCMAKE_BUILD_TYPE:STRING=RelWithDebInfo \
            -DCMAKE_C_FLAGS_RELWITHDEBINFO:STRING='$(cflags)' \
            -DCMAKE_CXX_FLAGS_RELWITHDEBINFO:STRING='$(cxxflags)' \
            -DCMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_MODULE_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_SHARED_LINKER_FLAGS_RELWITHDEBINFO:STRING='$(ldflags)' \
            -DCMAKE_SKIP_INSTALL_RPATH:BOOL=ON \
            -DCMAKE_INSTALL_PREFIX:PATH=/usr \
            -DCMAKE_INSTALL_LIBDIR:PATH=/usr/lib \
            -DLIB_SOVERSION=0.10 \
            -DLIB_VERSION=0.10.0 \
            -DOPENTURNS_SYSCONFIG_PATH:PATH=/etc/openturns-1.9 \
            -DINSTALL_DESTDIR:PATH=$(CURDIR)/debian/tmp \
            -DLINK_PYTHON_LIBRARY:BOOL=OFF \
            -DPYTHON_EXECUTABLE:FILEPATH=/usr/bin/python$* \
            -DPYTHON_INCLUDE_DIR:PATH=$$(python$*-config --includes | sed -e 's/ .*//' -e 's/^-I//') \
            -DPYTHON_INCLUDE_DIR2:PATH=$$(python$*-config --includes | sed -e 's/ .*//' -e 's/^-I//') \
            -DPYTHON_LIBRARY:PATH=$$(python$*-config --ldflags | sed -e 's/ .*//' -e 's/^-L//')/libpython$*.so

override_dh_auto_build: $(PYALL:python%=cmake-build-%)

cmake-build-%:
	$(MAKE) $(test_makeflags) -C build-python$*/lib
	$(MAKE) -j1 -C build-python$*/python
	$(MAKE) $(test_makeflags) -C build-python$*

override_dh_auto_install: debian/tmp/usr/lib/R/site-library/rot $(PYALL:python%=cmake-install-%)

cmake-install-%:
	dh_auto_install -Bbuild-python$*
	mkdir -p debian/libopenturns0.10-dbg/usr/lib/debug/usr/lib
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  R_LIBS_SITE=$(CURDIR)/debian/tmp/usr/lib/R/site-library \
	  $(MAKE) $(test_makeflags) -C build-python$* test ARGS="$(test_makeflags) -R pyinstallcheck"
endif

override_dh_makeshlibs:
	dh_makeshlibs -Xpyshared

override_dh_strip:
	dh_strip -plibopenturns0.10 --dbg-package=libopenturns0.10-dbg
	dh_strip

override_dh_python2:
	dh_python2 -p python-openturns

override_dh_python3:
	dh_python3 -p python3-openturns

override_dh_compress:
	dh_compress -X.pdf -X.git -X.py

override_dh_auto_test: $(PYALL:python%=cmake-test-%)

cmake-test-%:
	# 'make test' does not build binary tests
ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
	$(MAKE) $(test_makeflags) -C build-python$* tests
	LD_LIBRARY_PATH=$${LD_LIBRARY_PATH:+$${LD_LIBRARY_PATH}:}$(CURDIR)/debian/tmp/usr/lib \
	  CTEST_OUTPUT_ON_FAILURE=1 \
	  $(MAKE) -C build-python$* test ARGS="$(test_makeflags) -R cppcheck"
endif

get-orig-source:
	uscan --force-download --verbose
	mv ../openturn*.tar.[gzbz2]* ../tarballs
